/* Definitions for Intel 386 running SCO OpenServer Release 5.
   Borrowed from sco4.h which was
   Written by Chip Salzenberg.
   Ported to OpenServer Release 5 by Robert Lipe, 1995
   Copyright (C) 1992, 1994 Free Software Foundation, Inc.


Open Issues: 
 Find some floating point wizard to explain the 80 bit F-mode thing.


This file is part of GNU CC.

GNU CC is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2, or (at your option)
any later version.

GNU CC is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with GNU CC; see the file COPYING.  If not, write to
the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.  */

/* 
 * Mostly it's like AT&T Unix System V.  If COFF, we're more like
 * GCC's concept of an SVR3.2 box.  
 * If we're ELF, we probably really match GCC's concept of SVR4 closer,
 * but I never got that combination off the ground.
 */


#include "i386/sysv3.h"

/* By default, target has a 80387, uses IEEE compatible arithmetic,
   and returns float values in the 387, ie,
   (TARGET_80387 | TARGET_FLOAT_RETURNS_IN_80387)

   SCO's software emulation of a 387 fails to handle the `fucomp'
   opcode.  fucomp is only used when generating IEEE compliant code.
   So don't make TARGET_IEEE_FP default for SCO. 
   FIXME: Does anyone know how to test this assertion??
*/

#undef TARGET_DEFAULT
#define TARGET_DEFAULT 0201

/* 
   Let's guess that the SCO software FPU emulator can't handle
   80-bit XFmode insns, so don't generate them.  
*/
#undef LONG_DOUBLE_TYPE_SIZE
#define LONG_DOUBLE_TYPE_SIZE 64

/* Use atexit for static destructors, instead of defining
   our own exit function.  */
#define HAVE_ATEXIT

/* Specify the size_t type.  */
#define SIZE_TYPE "unsigned int"

/* caller has to pop the extra argument passed to functions that return
   structures. */

#undef RETURN_POPS_ARGS
#define RETURN_POPS_ARGS(FUNTYPE,SIZE)   \
  (TREE_CODE (FUNTYPE) == IDENTIFIER_NODE ? 0			\
   : (TARGET_RTD						\
      && (TYPE_ARG_TYPES (FUNTYPE) == 0				\
	  || (TREE_VALUE (tree_last (TYPE_ARG_TYPES (FUNTYPE)))	\
	      == void_type_node))) ? (SIZE)			\
   : 0)
/* On other 386 systems, the last line looks like this:
   : (aggregate_value_p (TREE_TYPE (FUNTYPE))) ? GET_MODE_SIZE (Pmode) : 0)  */

/* Handle #pragma pack. */
#define HANDLE_SYSV_PRAGMA


#define MD_STARTFILE_PREFIX "/usr/ccs/lib/"
#undef STARTFILE_SPEC
/* 
	Always use crt1.o as a startup file, but link the 
	"values-X?" that's appropriate for our environment
	so the runtime libraries (like libc) can figure out
	what to do for each of the flavors:
		-ansi strict ansi dialect of the lib, -Xc.
		if not -ansi, but -traditional, use transitional
			dialect of the lib, -Xt
		otherwise (default), use extended ANSI C, -Xa
		

*/
#define STARTFILE_SPEC  "/usr/ccs/lib/crt1.o 		\
	%{ansi:/usr/ccs/lib/values-Xc.o%s}			\
	%{!ansi:				\
		%{traditional:/usr/ccs/lib/values-Xt.o%s} 	\
		%{!traditional:/usr/ccs/lib/values-Xa.o%s} 	\
	}"


/* All environments use same end files. */
#undef ENDFILE_SPEC
#define ENDFILE_SPEC "-lcrypt -lgen -lc crtn.o%s "

/* Library spec.  
	We always use the same library, we just feed different  
	arguments to the linker.  Yes, the linker knows & cares.
	Unlike the SCO tools, we don't specify the binary type
 	to the linker.  We assume the linker driver [ that which
	calls coff ld or elf ld ] knows what it's doing.
*/

#undef LIB_SPEC
#define LIB_SPEC " 		\
 %{Ansi:			\
	-Ra,ansi		\
  } 				\
 %{Compat30:			\
	-Ra,ods30		\
  } 				\
 %{Posix:			\
	-Ra,posix		\
  } 				\
 %{Xpg4:			\
	-Ra,xpg4		\
  } 				\
 %{Xpg4plus:			\
	-Ra,xpg4plus		\
  } 				\
 -YP,/usr/ccs/lib:/lib:/usr/lib \
 " 

/* Macros, macros everywhere:
   Specify predefined symbols in preprocessor.  */

#undef CPP_PREDEFINES
#define CPP_PREDEFINES \
 "-Asystem(__unix) -Acpu(__i386) -Amachine(__i386)"

/* These may be overridden by sco5elf.h */
#ifndef __SCO_BINARY_MANIFESTS
#define __SCO_BINARY_MANIFESTS  "-D_M_COFF -D_SCO_COFF "
#endif
/* 
	Here, it's a little sad that the syntax won't let you have
	ors and ands.  i.e., "xpg4 || xpg4plus".

	NOTE: These are alphabetic, and are arranged in this order:

	Things common to all compilation environments.

	Things specific to specific environments.

	Things common to specific environments (defined in terms like
		"not posix and not compat30 and not ansi"
*/

#undef CPP_SPEC
#define CPP_SPEC 							\
 __SCO_BINARY_MANIFESTS 						\
 "-D__i386 -D_SCO_DS=1 -D__unix 					\
	-D_M_I386 -D_M_XENIX -D_M_UNIX 					\
  -D_SCO_C_DIALECT=1 							\
									\
  %{Ansi: 								\
	-I/usr/include/ansi 						\
	-D_STRICT_ANSI -D_STRICT_NAMES 					\
	} 								\
  %{Compat30: 								\
	-DM_BITFIELDS -DM_INTERNAT -DM_SYSV -DM_SYS5 -DM_SYSIII 	\
	-DM_WORDSWAP  							\
	-DM_I86 -DM_I86SM -DM_SDATA -DM_STEXT				\
	-D_SCO_ODS_30 							\
	} 								\
  %{Posix: 								\
	-I/usr/include/posix 						\
	-D_POSIX_SOURCE=1 -D_POSIX_C_SOURCE=2 -D_STRICT_NAMES 		\
	} 								\
  %{Xpg4: 								\
	-D_XOPEN_SOURCE=1  						\
	-I/usr/include/xpg4 						\
	} 								\
  %{Xpg4plus: 								\
	} 								\
									\
  %{!Ansi:%{!Compat30:%{!Posix: 					\
	-D_STRICT_NAMES -D_SCO_XPG_VERS=4 				\
	}}} 								\
  %{!Ansi:%{!Posix:%{!Xpg4: 						\
	-I/usr/include 							\
	-D_M_BITFIELDS -D_M_INTERNAT -D_M_SYSV -D_M_SYS5 -D_M_SYSIII 	\
	-D_M_WORDSWAP -Di386 -Dunix -DM_I386 -DM_UNIX -DM_XENIX 	\
	-D_M_I86 -D_M_I86SM -D_M_SDATA -D_M_STEXT 			\
	}}} 								\
"
    
/* The system headers are C++-aware.  */
#define NO_IMPLICIT_EXTERN_C

#define SDB_DEBUGGING_INFO
#define DWARF_DEBUGGING_INFO 

#define PREFERRED_DEBUGGING_TYPE SDB_DEBUG

#define SET_ASM_OP ".set"

#define IDENT_ASM_OP ".ident"

#define ASM_FILE_END(FILE)				\
	{						\
	fprintf((FILE), "\t%s\t\"GCC: (GNU) %s\"\n", 	\
	IDENT_ASM_OP, version_string);			\
	} 
/* 
 * This may be overridden in sco5elf.h.
 */
#if ! defined __SCO_EXTRA_LINK_SPECS
#define __SCO_EXTRA_LINK_SPECS ""
#endif

#define LINK_SPEC 					\
	"-YP,/usr/ccs/lib:/lib:/usr/lib" 		\
	__SCO_EXTRA_LINK_SPECS
